//+------------------------------------------------------------------+
//|                                                          EMI.mq4 |
//|                                 Copyright  2009, Roman Robidet. |
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright "Copyright  2009, Roman Robidet."

#property indicator_separate_window
//#property indicator_minimum 0
//#property indicator_maximum 100
#property indicator_buffers 1
#property indicator_color1 DodgerBlue

extern int EMIPeriod=13;
extern int SmoothPeriod = 0;

double EMIBuffer[];
double PosBuffer[];
double NegBuffer[];
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
   string short_name;

   IndicatorBuffers(1);
  
//---- indicator line
   SetIndexStyle(0,DRAW_LINE);
   SetIndexBuffer(0,EMIBuffer);
//---- name for DataWindow and indicator subwindow label
   short_name="EMI("+EMIPeriod+")";
   IndicatorShortName(short_name);
   SetIndexLabel(0,short_name);
//----
 
//----
   return(0);
  }

int start()
  {
   int  k;
   double _H,sumaEMI,EMV;
   double _B;
   double _HP;
   double _BP;
   double _V;
//----
      int limit;
     int counted_bars=IndicatorCounted();

     if(counted_bars<0) return(-1);

     if(counted_bars>0) counted_bars--;
     limit=MathMin(Bars-counted_bars,Bars-1);


//-- main loop
   
   for(int i=limit; i>=0; i--)
   {
            sumaEMI=0;
            for(k=0;k<EMIPeriod && (i+k+1)<Bars;k++)
            {
   
            _H=High[i+k];
            _B=Low[i+k];
            _HP=High[i+1+k];
            _BP=Low[i+1+k];
            _V=Volume[i+k];
            if ((_H-_B )!=0)
                  EMV=(((_H + _B ) / 2 ) - (( _HP + _BP )/2)) / ( _V / ( _H - _B )) * 10000000000 ;
            else  EMV=0;         
           sumaEMI=sumaEMI + EMV;
         
            }
            EMIBuffer[i]=iSsm(sumaEMI/ EMIPeriod,SmoothPeriod,i);
   }
   return(0);
}

//+------------------------------------------------------------------+

#define Pi 3.14159265358979323846264338327950288
double workSsm[][2];
#define _tprice  0
#define _ssm     1

double workSsmCoeffs[][4];
#define _speriod 0
#define _sc1    1
#define _sc2    2
#define _sc3    3

double iSsm(double price, double period, int i, int instanceNo=0)
{
   if (period<=1) return(price); i = Bars-i-1;
   if (ArrayRange(workSsm,0) !=Bars)                 ArrayResize(workSsm,Bars);
   if (ArrayRange(workSsmCoeffs,0) < (instanceNo+1)) ArrayResize(workSsmCoeffs,instanceNo+1);
   if (workSsmCoeffs[instanceNo][_speriod] != period)
   {
      workSsmCoeffs[instanceNo][_speriod] = period;
      double a1 = MathExp(-1.414*Pi/period);
      double b1 = 2.0*a1*MathCos(1.414*Pi/period);
         workSsmCoeffs[instanceNo][_sc2] = b1;
         workSsmCoeffs[instanceNo][_sc3] = -a1*a1;
         workSsmCoeffs[instanceNo][_sc1] = 1.0 - workSsmCoeffs[instanceNo][_sc2] - workSsmCoeffs[instanceNo][_sc3];
   }

   //
   //
   //
   //
   //

      int s = instanceNo*2; 
      workSsm[i][s+_ssm]    = price;
      workSsm[i][s+_tprice] = price;
      if (i>1)
      {  
          workSsm[i][s+_ssm] = workSsmCoeffs[instanceNo][_sc1]*(workSsm[i][s+_tprice]+workSsm[i-1][s+_tprice])/2.0 + 
                               workSsmCoeffs[instanceNo][_sc2]*workSsm[i-1][s+_ssm]                                + 
                               workSsmCoeffs[instanceNo][_sc3]*workSsm[i-2][s+_ssm]; }
   return(workSsm[i][s+_ssm]);
}